<template>
    <div v-if="visible" class="absolute left-0 top-0 w-full h-full bg-black bg-opacity-50 text-white rounded-lg" style="z-index: 99999999">
        <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center absolute right-0 top-0 mr-2 mt-2 pointer" v-on:click="reset()" style="z-index: 999999999">
            <img svg-inline class="fill-current inline-block w-8 h-8" src="./pix/zond/close-outline.svg" />
        </button>
        <div class="relative w-full h-full">
            <div v-if="activated" class="loading w-full h-full flex flex-col items-center m-auto py-4 justify-center">
                <slot name="loading" v-bind:data="d"></slot>
            </div>
            <div v-if="!activated && success" class="success w-full h-full flex flex-col items-center m-auto py-4 justify-center">
                <slot name="success" v-bind:data="d"></slot>
            </div>
            <div v-if="!activated && !success" class="failure w-full h-full flex flex-col items-center m-auto py-4 justify-center">
                <slot name="failure" v-bind:data="d"></slot>
            </div>
        </div>
    </div>
</template>
<script>
import './style.css';

export default{
    name: "WeeModal",
    props: {
        timeout: {
            type: Number,
            default: 1000
        }
    },
    data(){
        return {
            visible: false,
            activated: false,
            success: false,
            d: null
        };
    },
    methods: {
        activate(e){
            this.d = e;
            this.visible = true;
            this.activated = true;
        },
        done(e){
            let self = this;
            this.d = e;
            this.activated = false;
            this.success = true;
            setTimeout(function(){
                self.reset();
            }, this.timeout);
        },
        failed(e){
            let self = this;
            this.d = e;
            this.activated = false;
            this.success = false;
            setTimeout(function(){
                self.reset();
            }, this.timeout);
        },
        reset(){
            this.d = null;
            this.visible = false;
            this.activated = false;
            this.success = false;
        }
    }
}
</script>
<style>

</style>
